//
//	$Date: 2001/07/26 14:41:35 $
//	$Revision: 1.2 $
//


#if SDK_VERSION >= 35
#include <PalmOS.h>
#else
#include <Pilot.h>
#include "NewTypes.h"
#endif

#include "pwprefs.h"
#include "linkaction.h"

//
//	Save current application's information into PalmWiki's
//	preferences database
//
static Boolean SaveLink(WikiPref *prefp)
{
	DmOpenRef db,datadb;
	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	UInt16 i,n;
	UInt16 attr;

	Link *link;

	if(!GetWikiPreferences(prefp,true)){
		 return false; // no PalmWiki found
	}

	link = &(prefp->linkstack[prefp->linkstackindex]);
	link->appid = link->dataid = NULL;
	link->appcardno = link->datacardno = 0;
	link->recordno = 0xffff;

	datadb = NULL;
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'appl'){
			link->appcardno = cardno;
			link->appid = id;
		}
		if(type == 'DATA'){
			datadb = db;
			link->datacardno = cardno;
			link->dataid = id;
		}
		db = DmNextOpenDatabase(db);
	}
	if(link->appid == NULL){ // no application found
		return false;
	}

	if(datadb){
		n = DmNumRecords(datadb);
		for(i=0;i<n;i++){
			// look for a record under modification,
			// where the 'busy' bit is set
			DmRecordInfo(datadb,i,&attr,NULL,NULL);
			if((attr & dmRecAttrBusy) && !(attr & dmRecAttrDelete)){
				link->recordno = i;
				break;
			}
		}
		if(i >= n){ // no open record
//			StrNCopy(link->pattern,str,16);
//			link->pattern[15] = '\0';
		}
	}

	SetWikiPreferences(prefp);

	return true;
}

// if some action is available, returns true.
Boolean LinkAction(LinkActionType action)
{
	WikiPref pref;
	int i;

	switch(action){
	case LINKJUMP:
		if(!SaveLink(&pref)) return false;
		if(pref.linkstackindex+1 < MAXLINK){
			pref.linkstackindex++;
		}
		else {
			for(i=0;i<pref.linkstackindex;i++){
				pref.linkstack[i] = pref.linkstack[i+1];
			}
		}
		pref.linkstackmax = pref.linkstackindex;
		break;
	case LINKFORWARD:
		GetWikiPreferences(&pref,true);
		if(pref.linkstackindex >= pref.linkstackmax ||
		   pref.linkstackindex+1 >= MAXLINK) return false;
		pref.linkstackindex++;
		break;
	case LINKBACKWARD:
		GetWikiPreferences(&pref,true);
		if(pref.linkstackindex <= 0) return false;
		if(pref.linkstackindex == pref.linkstackmax){
			if(!SaveLink(&pref)) return false;
		}
		pref.linkstackindex--;
	}

	SetWikiPreferences(&pref);
	return true;
}

