//
//	$Date: 2004/01/29 05:26:44 $
//	$Revision: 1.13 $
//
//	PalmWiki Version = 0.4.1
//

#if SDK_VERSION >= 35
#include <PalmOS.h>
//#include <PalmCompatibility.h> // ÂSDKΉ
#else
#include <Pilot.h>
#include "NewTypes.h"
#endif

#include "id.h"
#include "DropModule.h" // Drag&DropW[pwb_
#include "palmwiki.h"
#include "pwprefs.h"
#include "linkaction.h"
#include "SonyChars.h"
#include "backbutton.h"

#define IsUpper(c) ((c) >= 'A' && (c) <= 'Z')
#define IsLower(c) ((c) >= 'a' && (c) <= 'z')
#define IsAlpha(c) (IsLower(c) || IsUpper(c))
#define IsDigit(c) ((c) >= '0' && (c) <= '9')
#define IsDelim(c) ((c) == '/' || (c) == '.')
#define IsSJIS(c) (((c) >= 0x80 && (c) <= 0x9f) || ((c) >= 0xe0 && (c) <= 0xfe))

#define FEATURE_CURSORPOS 10

typedef Err FldHandleEventTrapFunc(FieldPtr,EventPtr);

typedef enum {
	KEYWORD,
	WIKINAME,
	DATE,
	FAIL
} WikiType;

//WikiType FindKeyword(char *s,int pos,int length,int *start,int *end,WikiPref *prefp);
void LaunchMemo(char *str,char *app);
void LaunchSchedule(int year,int month,int day,char *app);

Boolean ConvertPOBox(unsigned char *pat, unsigned char *dst);
Boolean DoDragAndDrop(unsigned char *src, unsigned char *dst);

static unsigned long StringToLong(char *s)
{
	unsigned long val = 0;
	int i;

	for(i=0;i<4;i++){
		val = ((val << 8) + s[i]);
	}
	return val;
}

void
ReplaceString(char *s1, int b1, int e1, char *s2, int b2, int e2)
{
	char buf1[200],buf2[200];

	if(StrLen(s1+e1) > 200-1) return;
	if(e2-b2 > 200) return;

	StrCopy(buf1,s1+e1);
	StrNCopy(buf2,s2+b2,e2-b2);
	StrNCopy(s1+b1,buf2,e2-b2);
	StrCopy(s1+b1+e2-b2,buf1);
}

int
CheckWikiName(unsigned char *buf, UInt16 *start, UInt16 *end)
{
	int wstart, wend;
	int state;
	int i;
	char c;
	int l;
	int buflen = StrLen(buf);
	//
	// Check WikiNames
	//
	wstart = l = 0;
	while(l<*start){
		if(IsSJIS(buf[l])){
			l += 2;
			wstart = l;
			continue;
		}
		if(!IsAlpha(buf[l])){
			l++;
			wstart = l;
			continue;
		}
		l++;
	}
	for(wend= *end;wend<buflen;wend++){
		if(!IsAlpha(buf[wend])) break;
	}

	// check if buf[wstart..wend] is an WikiName
	state = 0;
	for(i=wstart;i<wend;i++){
		c = buf[i];
		switch(state){
		case 0:	if(IsUpper(c)) state = 1;
			else state = -1;
			break;
		case 1:	if(IsLower(c)) state = 2;
			else state = -1;
			break;
		case 2:	if(IsUpper(c)) state = 3;
			else if(IsLower(c)) state = 2;
			else state = -1;
			break;
		case 3:	if(IsLower(c)) state = 4;
			else state = -1;
			break;
		case 4:	if(IsUpper(c)) state = 3;
			else if(IsLower(c)) state = 4;
			else state = -1;
			break;
		default:
			break;
		}
	}
	if(state == 4){
		*start = wstart;
		*end = wend;
		return 1;
	}
	return 0;
}

Boolean
FindTag(unsigned char *buf, int start, int end, int *lp, int *rp, char *ltag, char *rtag)
{
	int buflen = StrLen(buf);
	int lfound, rfound;
	int l,r,lastl;
	int ltaglen = StrLen(ltag);
	int rtaglen = StrLen(rtag);

	lfound = 0;
	for(l=ltaglen;l<=start;){
		if(StrNCompare(buf+l-ltaglen,ltag,ltaglen)==0){
			lfound = 1;
			lastl = l;
		}
		if(IsSJIS(buf[l-ltaglen])) l+=2;
		else l++;
	}
	rfound = 0;
	for(r=end;r+rtaglen<=buflen;){
		if(buf[r+rtaglen]=='\n') break;
		if(StrNCompare(buf+r,rtag,rtaglen)==0){
			rfound = 1;
			break;
		}
		if(IsSJIS(buf[r])) r+=2;
		else r++;
	}
	if(lfound && rfound){
		*lp = lastl;
		*rp = r;
		return true;
	}
	return false;
}

Boolean
Get3Val(char *s, int ss, int ee,
	int *val1, int *val2, int *val3, int delim)
{
	int i;
	int start,end;
	int v1,v2,v3;
	int delimcount;

	for(i=ss;i<ee;i++){
		if(!IsDigit(s[i]) && (s[i] != delim)) return false;
	}

	v1 = v2 = v3 = 0;
	for(start=ss;start>=0;start--){
		if(!IsDigit(s[start]) && s[start] != delim) break;
	}
	start++;
	for(end=ee;s[end];end++){
		if(!IsDigit(s[end]) && s[end] != delim) break;
	}

	// check if this really looks like a date string
	delimcount = 0;
	for(i=start;i<end;i++){
		if(IsDigit(s[i])) continue;
		if(s[i] == delim){
			delimcount++;
			continue;
		}
		return false;
	}
	if(delimcount != 2) return false;

	for(i=start;i<end && s[i] != delim;i++){
		v1 = v1 * 10 + s[i] - '0';
	}
	i++;
	for(;i<end && s[i] != delim;i++){
		v2 = v2 * 10 + s[i] - '0';
	}
	i++;
	for(;i<end;i++){
		v3 = v3 * 10 + s[i] - '0';
	}
	*val1 = v1;
	*val2 = v2;
	*val3 = v3;
	return true;
}

Boolean
CheckCalendar(char *s, int start, int end, char *app)
{
	unsigned long pref;
	int year,month,day;
	Boolean ok;

	pref = PrefGetPreference(prefDateFormat);

	switch(pref){
	case dfMDYWithSlashes:		// 12/31/95
		ok = Get3Val(s,start,end,&month,&day,&year,'/'); break;
	case dfDMYWithSlashes:		// 31/12/95
		ok = Get3Val(s,start,end,&day,&month,&year,'/'); break;
	case dfDMYWithDots:		// 31.12.95
		ok = Get3Val(s,start,end,&day,&month,&year,'.'); break;
	case dfDMYWithDashes:		// 31-12-95
		ok = Get3Val(s,start,end,&day,&month,&year,'-'); break;
	case dfYMDWithSlashes:		// 95/12/31
		ok = Get3Val(s,start,end,&year,&month,&day,'/'); break;
	case dfYMDWithDots:		// 95.12.31
		ok = Get3Val(s,start,end,&year,&month,&day,'.'); break;
	case dfYMDWithDashes:		// 95-12-31
		ok = Get3Val(s,start,end,&year,&month,&day,'-'); break;
	default:	
		ok = Get3Val(s,start,end,&year,&month,&day,'/'); break;
	}
	if(!ok) return false;
	if(month >= 1 && month <= 12 && day >= 1 && day <= 31){
		if(year < 70){ year += 2000; }
		else if(year < 100){ year += 1900; }
		LaunchSchedule(year,month,day,app);
		return true;
	}
	return false;
}

//
//	Replace sysTrapFldHandleEvent() with this hack function
//
Err Wiki(FieldPtr fld, EventPtr e)
{
	UInt32 ftrvalue;
	Err ret;
	char *fieldtext;
	int fieldsize;
	UInt16 selstart,selend;
	int start,end,fieldlength;
	char buf[200];
	char buf2[200];
	char pat[200];
	WikiPref pref;
	UInt16 lastpos, newpos;
	int ltaglen,rtaglen;
	int l,r;
	Boolean found;
	Boolean launchmemo = false;

#ifdef HACK
	FldHandleEventTrapFunc *trapfunc;
	//
	// Get the original trap address of FldHandleEvent and
	// invoke it.
	//
	FtrGet(PWCREATOR,1000,&ftrvalue);
	trapfunc = (FldHandleEventTrapFunc*)ftrvalue;
	ret = (*trapfunc)(fld,e);
#endif

	fieldtext = FldGetTextPtr(fld);
	if(fieldtext == NULL) return ret;

	fieldlength = FldGetTextLength(fld);

	selstart = selend = 0;
	switch(e->eType){
	case penDownEvent:
		//
		// Get preferences
		//
		GetWikiPreferences(&pref,true);

		// remember current cursor position
		newpos = FldGetInsPtPosition(fld);
		ftrvalue = newpos;
		FtrSet(PWCREATOR,FEATURE_CURSORPOS,ftrvalue); 

		return ret;

		break;
	case tblEnterEvent:	//#####
	case fldEnterEvent:
		//dragging, etc.

		//
		// Get preferences
		//
		GetWikiPreferences(&pref,true);

		FldGetSelection(fld,&selstart,&selend);

		if(pref.singletap){
			if(selstart != selend) return ret;
		}
		else {
			// get last cursor position
			FtrGet(PWCREATOR,FEATURE_CURSORPOS,&ftrvalue);
			lastpos = ftrvalue;
			if(lastpos < selstart || lastpos > selend) return ret;
		}
		break;
	default:
		return ret;
	}

	GetWikiPreferences(&pref,true);

	for(start=selstart;start>0;start--){
		if(fieldtext[start-1]=='\n') break;
	}
	fieldsize = FldGetTextLength(fld);
	for(end=selend;end<fieldsize;end++){
		if(fieldtext[end]=='\0'||fieldtext[end]=='\n') break;
	}
	if(end-start >= 200-1) end = start+200-1;
	StrNCopy(buf,fieldtext+start,end-start);
	StrCopy(buf+end-start,"");
	selend = selstart = selstart-start;
	ltaglen = StrLen(pref.lpar);
	rtaglen = StrLen(pref.rpar);
	for(;;){
		if(selstart != selend){
			// look for POBox dictionary and convert it if applicable
			if(selend-selstart >= 200-1) return ret;
			StrNCopy(pat,buf+selstart,selend-selstart);
			StrCopy(pat+selend-selstart,"");
			if(ConvertPOBox((unsigned char*)pat,(unsigned char*)buf2)){
				Boolean usedata;
				usedata = DoDragAndDrop(pat,buf2);
				if(!usedata) return ret;
				ReplaceString(buf,selstart,selend,buf2,0,StrLen(buf2));
			}
		}

		found = FindTag(buf,selstart,selend,&l,&r,pref.lpar,pref.rpar);
		if(found){
			ReplaceString(buf,l-ltaglen,r+rtaglen,buf,l,r);
			selstart = l-ltaglen;
			selend = r - ltaglen; 
		}
		else {
			if(pref.usewikiname){
				CheckWikiName(buf,&selstart,&selend);
			}
			if(selstart != selend){
				ReplaceString(buf,0,selend-selstart,buf,selstart,selend);
				StrCopy(buf+selend-selstart,"");
				selend = selend - selstart;
				selstart = 0;
				launchmemo = true;
			}
			break;
		}
	}
	if(! CheckCalendar(buf,selstart,selend,pref.date) && launchmemo){
		LaunchMemo(buf,pref.memo);
	}
	return ret;
}

void LaunchMemo(char *str, char *app)
{
	int i;
	int nrecords;
	DmOpenRef db,memo;
	MemHandle h;
	char *s0;
	int size;
	UInt16 recordno;
	Err err;
	Boolean found;

	GoToParamsType *cmdPBP;
	LocalID memoappid;
	unsigned short memoappcardno;
	LocalID memodbid;
	unsigned short memodbcardno;
	DmSearchStateType state;

	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	Boolean memoisopen;

	LinkAction(LINKJUMP);

	// check all the open database and see if memo is currently open
	memoisopen = false;
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'DATA' && creator == 'memo'){
			memoisopen = true;
			break;
		}
		db = DmNextOpenDatabase(db);
	}
	if(memoisopen){
		memo = db;
	}
	else {
		memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	}
	if(memo == NULL) return;

	nrecords = DmNumRecords(memo);
	recordno = nrecords;
	found = false;
	StrCat(str,"\n");
	for(i=nrecords-1;i>=0 && !found;i--){
		h = DmQueryRecord(memo,i);
		if(h && (s0 = MemHandleLock(h))){
			size = MemPtrSize(s0);
			if(size >= StrLen(str) && StrNCompare(s0,str,StrLen(str))==0){
				recordno = i;
				found = true;
			}
			MemHandleUnlock(h);
		}
	}
	if(!found){
		h = DmNewRecord(memo,&recordno,StrLen(str)+1);
		if(h && (s0 = MemHandleLock(h))){
			err = DmWrite(s0,0,str,StrLen(str)+1);
			ErrFatalDisplayIf(err,"DmWrite");
			DmReleaseRecord(memo,recordno,true);
			MemHandleUnlock(h);
		}
	}
	DmOpenDatabaseInfo(memo,&memodbid,NULL,NULL,&memodbcardno,NULL);
	if(!memoisopen){
		DmCloseDatabase(memo);
	}

	//
	// Launch the 'memo' application. This seems to work even where
	// memo is already running.
	//
	cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
	DmGetNextDatabaseByTypeCreator(true,&state,'appl',
		StringToLong(app), // 'memo', etc.
		false,&memoappcardno,&memoappid);
	cmdPBP->searchStrLen = 0;
	cmdPBP->dbCardNo = memodbcardno;
	cmdPBP->dbID = memodbid;
	cmdPBP->recordNum = recordno;
	cmdPBP->matchPos = 0;
	cmdPBP->matchFieldNum = 0; 
	cmdPBP->matchCustom = 0;
	MemPtrSetOwner((MemPtr)cmdPBP,0);
	SysUIAppSwitch(memoappcardno,memoappid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);
}

void LaunchSchedule(int year,int month,int day,char *app)
{
//	unsigned char newdata[20];

	int nrecords;
	DmOpenRef db,schedule;
	MemHandle h;
	unsigned char *s0;
	UInt16 recordno, lastrecordno;

	GoToParamsType *cmdPBP;
	LocalID scheduleappid;
	unsigned short scheduleappcardno;
	LocalID scheduledbid;
	unsigned short scheduledbcardno;
	DmSearchStateType state;

	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	Boolean scheduleisopen;

	long diff,newdiff;

	Boolean found;
	Boolean nodata;

	DateType date, jumpdate;
	unsigned long days, jumpdays;

	LinkAction(LINKJUMP);

	// check all the open database and see if schedule is currently open
	scheduleisopen = false;
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'DATA' && creator == 'date'){
			scheduleisopen = true;
			break;
		}
		db = DmNextOpenDatabase(db);
	}
	if(scheduleisopen){
		schedule = db;
	}
	else {
#ifdef CREATERECORD
		schedule = DmOpenDatabaseByTypeCreator('DATA','date',dmModeReadWrite);
#else
		schedule = DmOpenDatabaseByTypeCreator('DATA','date',dmModeReadOnly);
#endif
	}
	if(schedule == NULL) return;

	found = false;
	nodata = true; // even when nrecords > 0, all the data might have been deleted.
	nrecords = DmNumRecords(schedule);
	if(nrecords <= 0) return; // no schedule data

	lastrecordno = 0;
	diff = -1;
	jumpdate.year = year-1904;
	jumpdate.month = month;
	jumpdate.day = day;
	jumpdays = DateToDays(jumpdate);

	for(recordno=0;recordno<nrecords;recordno++){
		h = DmQueryRecord(schedule,recordno);
		if(h) nodata = false;
		if(h && (s0 = MemHandleLock(h))){
			date = *((DateType*)(s0+4));
			MemHandleUnlock(h);

			days = DateToDays(date);

			newdiff = (long)days - (long)jumpdays;
			if(newdiff < 0) newdiff = -newdiff;
			if(newdiff < diff || diff < 0){
				lastrecordno = recordno;
				diff = newdiff;
			}
		}
	}

	if(1){ // if(! found){
#ifdef CREATERECORD
		//
		// create a new record with no time specification
		//
		MemMove(newdata,"\377\377\377\377xx\004\262(new data)\000",19);
		packed = ((year-1900-4)<<9)+(month<<5)+day;
		newdata[4] = (packed>>8);
		newdata[5] = (packed&0xff);

		h = DmNewRecord(schedule,&recordno,19);
		if(h && (s0 = MemHandleLock(h))){
			err = DmWrite(s0,0,newdata,19);
			ErrFatalDisplayIf(err,"DmWrite");
			DmReleaseRecord(schedule,recordno,true);
			MemHandleUnlock(h);
		}
#else
		recordno = lastrecordno;
#endif
	}
	DmOpenDatabaseInfo(schedule,&scheduledbid,NULL,NULL,&scheduledbcardno,NULL);
	if(!scheduleisopen){
		DmCloseDatabase(schedule);
	}

	if(nodata) return;

	//
	// Launch the 'schedule' application. This seems to work even where
	// schedule is already running.
	//
	cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
	DmGetNextDatabaseByTypeCreator(true,&state,'appl',
		StringToLong(app), // 'date', etc.
		false,&scheduleappcardno,&scheduleappid);
	cmdPBP->searchStrLen = 0;
	cmdPBP->dbCardNo = scheduledbcardno;
	cmdPBP->dbID = scheduledbid;
	cmdPBP->recordNum = recordno;
	cmdPBP->matchPos = 0;
	cmdPBP->matchFieldNum = 0; 
	cmdPBP->matchCustom = 0;
	MemPtrSetOwner((MemPtr)cmdPBP,0);
	SysUIAppSwitch(scheduleappcardno,scheduleappid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);
}


// Inline POBox̒萔Ȃ
#define DICTYPE 'EDIC'
#define LDICTYPE 'LDIC'
#define CREATORID 'PBIN'

int
NextDictRecord(int resid, int c, char *extra, int nextra);

Boolean
ConvertPOBox(unsigned char *pat, unsigned char *new)
{
	DmOpenRef dic;                // POBoxInline 
	DmOpenRef ldic;               // wKPDB
	
#define MAXEXTRA 0x100
	unsigned char extra[MAXEXTRA];
	int nextra;
	int i;

	register unsigned char *s,*p,*sw;
	DmOpenRef ds;
	Boolean found;
	int resid;
	MemHandle h;

//WinDrawChars(pat,StrLen(pat),40,10);

	if(pat == NULL || *pat == NULL) return false;

	// Open POBox dictionaries... ldic may by NULL
	ldic = DmOpenDatabaseByTypeCreator(LDICTYPE,CREATORID,dmModeReadOnly);
	dic = DmOpenDatabaseByTypeCreator(DICTYPE,CREATORID,dmModeReadOnly);
	if(dic == NULL) return false;

	//
	//	g̐Ɛ擪𒲍
	//
	nextra = DmNumRecords(dic) - 0xa00;
	if(nextra > MAXEXTRA) nextra = MAXEXTRA;
	for(i=0;i< nextra;i++){
		unsigned char *s0;
		MemHandle h;
		h = DmQueryRecord(dic,0xa00+i);
		ErrFatalDisplayIf(h==NULL,"Can't open extra dictionary area");
		s0 = MemHandleLock(h);
			extra[i] = *s0;
		MemHandleUnlock(h);
	}

	//
	//	Search POBox dictionaries and make the transition table.
	//
	//
	// {Pꎫ/gPꎫ̊S}b`
	//
	resid = (int)(*pat);

	ds = (resid < 0x100 && ldic ? ldic : dic);

	found = false;
	while(!found && resid){
		h = DmQueryRecord(ds,resid);
		if(h && (s = MemHandleLock(h))){
			while(*s){ // DB̍ŌNULL
				sw = s;
				for(p = pat;*p && (*p == *s || *s == ' '); p++,s++);
				if(*p == '\0'){
					if(*s == '\0' || *s == '\002' || *s == ' '){
						found = true;
						break;
					}
/*
					for(;*s && *s != '\002';s++);
					s++;
					found = true;
					break;
*/
				}
				for(;*s;s++);
				s++;
			}
			MemHandleUnlock(h);
			if(found){
				p = new;
				s = sw;
				while(*s){
					if(*s == '\002'){
						p = new;
						s++;
						continue;
					}
					*p++ = *s++;
				}
				*p = '\0';
				break;
			}
		}
		//
		// ̒Pꎫ
		//
		resid = NextDictRecord(resid,(int)(*pat),extra,nextra);
		ds = dic;
	}
	if(dic) DmCloseDatabase(dic);
	if(ldic) DmCloseDatabase(ldic);
	return found;
}

int
NextDictRecord(int resid, int c, char *extra, int nextra)
{
	if(resid == c){
		resid = 0xa00;
	}
	else {
		resid++;
	}
	for(;resid < 0xa00 + nextra;resid++){
		if(extra[resid - 0xa00] == c) return resid;
	}
	return 0;
}

// Returns true if the result should be used for invoking Memo app.
Boolean
DoDragAndDrop(unsigned char *src, unsigned char *dst)
{
	int len,srclen;
	//
	//  Drag&DropW[Ăяo
	//
	len = StrLen(dst);
	srclen = StrLen(src);
	if(len >= 6 && dst[len-1] == '}'){
		//  W[CreatorID𒆊ʂłĎw肷B
		//  e.g. "ds#{PBTS}"  ([U`̏ꍇ)
		//  s蒷̏ꍇ́Ał}b`eLXgƂċ󔒕g
		//  "1<sp><sp><sp>...<sp>#{CTAB}"
		//  ̂悤ɒ`BW[@\T|[gĂꍇ
		//  "1<sp><sp><sp>...<sp>#{CTAB2}"
		//  ̂悤ɂB
		//  ܂A"@word" ȂǂƃvtBNXƂɃW[
		//  Ăяo悤ɂꍇ
		//  "@<sp><sp><sp>...<sp>#@{CTAB2}"
		//  ̂悤ɋʃvtBNXw肷ƁA
		//  vtBNX񂪃W[ɂ킽B
		//
		unsigned char *s,*p;
		int start;
		s = src;
		p = dst;
		for(start=0;s[start]==p[start];start++); // vtBNXXLbv
		if(p[start]=='{' && len-start >= 6){
			Err err;
			unsigned short cardNo;
			unsigned long result;
			LocalID dbID;
			DmSearchStateType searchState;
			tDropLaunchCmdParamRec *cmdPBP;
			unsigned long creatorID;

			creatorID = StringToLong(dst+start+1);

			// AvP[V̌
			err = DmGetNextDatabaseByTypeCreator (true, &searchState, 
				/*sysFileTApplication*/'appl', creatorID, false, &cardNo, &dbID);
			if(err) return true;

			cmdPBP = (tDropLaunchCmdParamRec*)MemPtrNew(sizeof(tDropLaunchCmdParamRec));
			cmdPBP->selector = ((dst[start+5] >= '0' && dst[start+5] <= '9') ? dst[start+5]-'0' : 0); // W[̉Ԗڂ̋@\
			cmdPBP->srcTextLength = srclen - start;
			cmdPBP->srcText = src + start;
			cmdPBP->resultTextLength = 0;
			cmdPBP->resultText = NULL;
			cmdPBP->resultBehavior = 0;
			
			MemPtrSetOwner((MemPtr)cmdPBP,0);

			LinkAction(LINKJUMP);
			
			err = SysAppLaunch (cardNo, dbID, 0,
				dDropLaunchCmd, (MemPtr)cmdPBP, &result);
			ErrFatalDisplayIf(err, "Error sending lookup action to app");

			if(! cmdPBP->resultText) return false;
			StrNCopy(dst,cmdPBP->resultText,cmdPBP->resultTextLength);
			dst[cmdPBP->resultTextLength] = '\0';
			MemPtrFree(cmdPBP->resultText); // 󂯎FreeƂD&D̎dl
		}
	}
	return true;
}

#ifdef APP

// Armx[XOS5@̏ꍇANotificationŕԂĂf[^\̃GfBA
// Arm̂̂ɂȂĂ̂ŁAꍇɂĂЂԂKv炵B
#define Swap16(n) (((((UInt16) n) << 8) & 0xFF00) | ((((UInt16) n) >> 8) & 0x00FF))

#define myDeferredNotifyEvent 'mydf'
#ifndef sysNotifyEventDequeueEvent // Ân
#define sysNotifyEventDequeueEvent 'hede'
#endif
Boolean PrefsHandleEvent(EventPtr event);

Boolean NotificationAvailable()
{
	UInt32 feature;

	return FtrGet(sysFtrCreator,sysFtrNumNotifyMgrVersion, &feature) == errNone;
}

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err err;
	DmSearchStateType state;
	UInt16 cardNo;
	LocalID dbid;

	EventPtr ep;
	EventType e;

	FormPtr frm;
	FieldPtr fld;
	TablePtr tbl;	//#####
	UInt16 idx;

	switch(cmd){
	case sysAppLaunchCmdNormalLaunch:
	case sysAppLaunchCmdReturnFromPanel:
	case sysAppLaunchCmdPanelCalledFromApp:
		// Open the preference panel
		if(! NotificationAvailable()){
			FrmAlert(ID_ALERT_NONOTIFICATION);
			return 0;
		}
		err = DmGetNextDatabaseByTypeCreator(true,&state,APPTYPE,PWCREATOR,true,&cardNo, &dbid);
		if(err != errNone) return 0;

		FrmGotoForm(ID_PREFS_FORM);
		do {
			EvtGetEvent(&e, evtWaitForever);
			if(PrefsHandleEvent(&e)) continue;
			if(SysHandleEvent(&e)) continue;
			if(MenuHandleEvent(NULL, &e, &err)) continue;
			FrmDispatchEvent(&e);
		}
		while (e.eType != appStopEvent);
		frm = FrmGetActiveForm();
		if(frm){
			FrmEraseForm(frm);
			FrmDeleteForm(frm);
		}

		SysNotifyRegister(cardNo,dbid,sysNotifyEventDequeueEvent,NULL,sysNotifyNormalPriority,NULL);
		return 0;
	case sysAppLaunchCmdSystemReset:
		// Enable Wiki when the system is reset.
		if(NotificationAvailable()){
			err = DmGetNextDatabaseByTypeCreator(true,&state,APPTYPE,PWCREATOR,true,&cardNo, &dbid);
			if(err != errNone) return 0;
			SysNotifyRegister(cardNo,dbid,sysNotifyEventDequeueEvent,NULL,sysNotifyNormalPriority,NULL);
		}
		return 0;
	case sysAppLaunchCmdNotify:
		err = DmGetNextDatabaseByTypeCreator(true,&state,APPTYPE,PWCREATOR,true,&cardNo, &dbid);
		if(err != errNone) return 0;
		if(((SysNotifyParamType*)cmdPBP)->notifyType == sysNotifyEventDequeueEvent){
			if(ep = (EventPtr)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP)){
				SysNotifyParamType notifyParam;
				switch(Swap16(ep->eType)){
				case tblEnterEvent: // Only register the notification here. //######
				case fldEnterEvent: // Only register the notification here.
					// Create the notification block.
					notifyParam.notifyType = myDeferredNotifyEvent;
					notifyParam.broadcaster = PWCREATOR;
					notifyParam.notifyDetailsP= ((SysNotifyParamType*)cmdPBP)->notifyDetailsP;
					notifyParam.handled = false;
					SysNotifyRegister(cardNo,dbid, myDeferredNotifyEvent, NULL, sysNotifyNormalPriority, NULL );
					// Broadcast the notification
					SysNotifyBroadcastDeferred( &notifyParam, sizeof(SysNotifyAppLaunchOrQuitType) );
					break;
				case keyDownEvent:
					switch(Swap16(ep->data.keyDown.chr)){
					case vchrJogBack:
					case prevFieldChr:
						if(JumpApp(LINKBACKWARD)){
							ep->eType = Swap16(nilEvent);
							return 0;
						}
						break;
					case vchrJogRelease:
					case nextFieldChr:
						if(JumpApp(LINKFORWARD)){
							ep->eType = Swap16(nilEvent);
							return 0;
						}
						break;
					default:
						break;
					}
				default:
					break;
				}
			}
		}else if( ((SysNotifyParamType*)cmdPBP)->notifyType == myDeferredNotifyEvent ){
			ep = (EventPtr)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP);
			if( SysNotifyUnregister(cardNo,dbid,myDeferredNotifyEvent,sysNotifyNormalPriority )!= errNone ){
				ErrDisplayFileLineMsg(__FILE__, (UInt16) __LINE__, "SysNotifyUnregister fail");
				return false;
			}
			frm = FrmGetActiveForm();
			idx = FrmGetObjectIndex(frm,Swap16(ep->data.fldEnter.fieldID));
			switch(Swap16(ep->eType)){
			case tblEnterEvent:
				tbl = FrmGetObjectPtr(frm,idx);
				e.eType = tblEnterEvent;
				fld = TblGetCurrentField(tbl);
				Wiki(fld,&e);
				break;
			case fldEnterEvent:
				fld = FrmGetObjectPtr(frm,idx);
				e.eType = fldEnterEvent;
				Wiki(fld,&e);
				break;
			}
		}
		return 0;
	default:
		return 0;
	}
}
#endif
